package ElchemeaHeader;
#$Id: ElchemeaHeader.pm,v 1.13 2014/12/10 11:32:17 sofc Exp $
$ENV{'PATH'} = '/bin:/usr/bin:/usr/local/bin';
use strict;
use warnings;
use Fcntl qw(:DEFAULT :flock);
use POSIX;

BEGIN {
    use Exporter ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
    $VERSION = '6.0.4';
    %EXPORT_TAGS = (
        'standard'=>[qw/$homedir $libdir $htmldir $plotfile $measurelock $devicelock $user_exec_dir $multiplex_channel_file $programlock $chrono_runforever_semafore $userdir/]
		    );
    Exporter::export_ok_tags('standard');
    Exporter::export_tags('standard');
    @ISA = qw(Exporter);
}
my @lt = localtime();
my $year = $lt[5]+1900;

my $WEB = '/home/http/html/';
#### Global file locations ####
our $homedir = '/home/elchemea/';
our $userdir = $homedir.'users/';
our $libdir = '/usr/local/bin/elchemea/';
our $htmldir = $WEB.'elchemea/';
our $configfile = $homedir.'Elchemea.conf';
our $configlock = $homedir.'Elchemea.lock';
our $plotfile = $htmldir.'png/current.png';
our $measurelock = '/tmp/measurelock.lock';
our $devicelock = '/tmp/devicelock.lock';
our $user_exec_dir = $libdir.'user_exec/';
### Program semafore files ###
our $multiplex_channel_file = '/tmp/multiplex_cannel.txt';
our $programlock = '/tmp/userprogram.lock';
our $chrono_runforever_semafore = '/tmp/chronoforever.lock';
#### End global file locations ####
our $COPYYEAR = '2011 - '.$year;
our $IMPLEMENTERS = 'S&oslash;ren Koch and Martin Nielsen';
#our $COPYRIGHT = 'Ris&oslash; DTU Fuel cells and Solid State Chemistry Division';
our $COPYRIGHT = 'DTU Energy';
our $DESIGNERS = 'S&oslash;ren Koch and Karin Vels Hansen';
our $TESTERS = '';

return 1;
