#!/usr/bin/perl
#$Id: net_status.cgi,v 1.8 2014/09/02 14:11:26 mnni Exp $
use strict;
use warnings;
use CGI qw(:standard :netscape);
use IO::Interface::Simple;
use Elchemea;
use ElchemeaCGI;
print header;
my $u = param('user');
my $p = param('pass');
exit unless (&ElchemeaCGI::login_ok($u,$p));
my $a = param('action');
if ($a && $a eq 'ON')
{
    eval
    {
	&Elchemea::CGI_client('start_network');
	&Elchemea::CGI_client('start_remote');
    };
    if ($@)
    {
	Elchemea::EFAlog($@);
	print "ERROR\n";
	print $@,"\n";
	exit;
    }
}
if ($a && $a eq 'OFF')
{
    eval {
	### This command is allowed to fail silently! ###
	&Elchemea::CGI_client('stop_remote');
    };
    if ($@)
    {
	Elchemea::EFAlog($@);
    }
    eval {
	&Elchemea::CGI_client('stop_network');
    };
    if ($@)
    {
	Elchemea::EFAlog($@);
	print "ERROR\n";
	print $@,"\n";
	exit;
    }
}


#### Try to get ip address of netwrok interface ###
my $devicename = Elchemea::get_config_value('network', 'devicename' );	# default name
$devicename = 'eth' unless( $devicename );
my @ilst = split(/\s*\,\s*/,$devicename);

my $local = '';
my @ifl = IO::Interface::Simple->interfaces();
OUTER:
foreach my $try (@ilst)
{
    foreach my $interface (@ifl)
    {
        if ($interface =~ /$try/)
        {
            my $if = IO::Interface::Simple->new($interface);
            $local = $if->address();
            last OUTER if ($local);
        }
    }
}

my $isRemote = Elchemea::CGI_client('is_remote'); # check to see if remote CGI server is up running 

my $port    =  get_config_value('remote','port');
if ($local)
{
    print "ON\n";
    print "Listening on $local port $port $isRemote\n";
}
else
{
    print "OFF\n";
    print "Network not active \n";
}

