#!/usr/bin/perl
#$Id: potsim.cgi,v 1.3 2011/03/23 07:23:02 sofc Exp $
use strict;
use warnings;
use Elchemea;
use ElchemeaUser;
use ElchemeaHeader;
use ElchemeaCGI;
use SemaforeFile;
use CGI qw(:standard :netscape);

my $u = param('user');
my $p = param('pass');
exit unless (&ElchemeaCGI::login_ok($u,$p));
my $user = ElchemeaUser->new($u);
my @list = $user->get_potsweep_points($user->session);
my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
my %pots = ();
foreach my $tag ($pot->setup_tags_potsweep)
{
    $pots{$tag} = $user->get_config_value('potsweep',$tag,$user->session);
}
my $ttime = Elchemea::format_time($pot->sweep_time(\%pots,\@list) + $user->get_offset_program_time('potsweep'));
my $rate = $pots{'sweep_rate'};
my $sweeps = $pots{'sweeps'};


my @l = @list;
while ($sweeps-- > 1)
{
    foreach (@l)
    {
	push @list,$_;
    }
}

my $t = 0;
my @out = ();
push @out, "$t\t$list[0]";
for (my $x = 1; $x < @list; $x++)
{
    my $time = abs($list[$x] - $list[$x-1])/$rate;
    next unless ($time);
    $t += $time;
    push @out,"$t\t$list[$x]";
}
my $gp = SemaforeFile->new('/tmp/potsim_'.$$.'.gp');
$gp->lock_ex;
my $f = '/tmp/potsim.txt';
my $png = '/elchemea/png/psim'.$$.'.png';
open DATA,'>',$f or die "Could not open file '$f' for writing: $!";
print DATA join("\n",@out),"\n";
close DATA;
my @gp = ();
push @gp, 'set nokey';
push @gp, 'set zeroaxis linetype -1';
push @gp, "set xla 'time (S)'";
push @gp, "set ylabel 'Polarisation'";
push @gp, "set term ".Elchemea::get_config_value('GNUPLOT','term');
push @gp, 'set size '.get_config_value('GNUPLOT','potsize');
push @gp, "set out '/home/http/html$png'";
push @gp, "plot '$f' u 1:2 with lines";
$gp->writeline(@gp);
my $cmd = get_config_value('GNUPLOT','location').' '.$gp->filename;
system($cmd);
unlink $gp->filename if ($gp->exist);
unlink $f if (-e $f);
$gp->unlock;

print header();
print $ttime,"\n";
print $png,"\n";
Elchemea::CGI_client('rmpng','psim'.$$.'.png');
exit;
