#!/usr/bin/perl -T
# $Id: show_file.cgi,v 1.17 2013/03/21 14:15:32 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use SemaforeFile;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);
use File::Copy;
my $file;
my $file_base;
my $file_basename;
my $user;
my $dir;
my @list;
my $log;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	my $session = param('session');
	$session = $user->session unless ($session);
	my $nr = param('file');
	$nr = $user->get_measure_nr unless ($nr);
	$dir = $userdir.$user->name.'/'.$session.'/';
	my $fn = 's'.$session.'_'.$nr.'.log';
	my @l = Elchemea::get_dir_list($dir,$fn);
	$file_base = $dir.$l[0] if (@l);
	$log = $file_base;
	$file_base =~ s/\.log$// if ($file_base);
	if ($file_base =~ /\/([\w\.\-]+)$/)
	{
	    $file_basename = $1;
	}
	foreach ('.i2b','.i2c','.i2p','.i2t')
	{
	    next unless (-e $file_base.$_);
	    $file = $file_base.$_;
	}
	@list = Elchemea::get_dir_list($dir,'.log');
	print_header("Elchemea data view");   
	my $prev = &find_prev();
	my $next = &find_next();
	top_nav_bar_start();
        top_nav_bar_button('','','action','Show data','s5','session,,','file,,','showmode,,');
        top_nav_bar_button('','','action','Show log','s6','session,,','file,,','showmode,,');
        top_nav_bar_button('view_session.cgi','','','Session view','s8');
        tab_newrow();
        js_back();
        top_js_return('#006600','white');
	my $a = param('action');
	$a = '' unless ($a && $a =~ /Show/);
	if ($prev)
	{
	    top_nav_bar_button('','','',' < ','s3','session,,','file,'.$prev.',1','action,'.$a.',1','showmode,,');
	}
	else
	{
	    top_no_button();   
	}
	if ($file =~ /i2b/)
	{
	    my $smode = param('showmode');
	    $smode = 'Impedance' unless ($smode);
	    if ($smode eq 'Impedance')
	    {
		top_nav_bar_button('','','action','Show bode plot','s3','session,,','file,,','showmode,Bode,1');
	    }
	    else
	    {
		top_nav_bar_button('','','action','Show impedance plot','s3','session,,','file,,','showmode,Impedance,1');
	    }
	}
	else
	{
	    top_nav_bar_button('','','action','Show graph','s3','session,,','file,,','showmode,,');
	}
	if ($next)
	{
	    top_nav_bar_button('','','',' > ','s3','session,,','file,'.$next.',1','action,'.$a.',1','showmode,,');
	}
	else
	{
	    top_no_button();
	}
	top_nav_bar_button('main.cgi','','','To menu','s4');
        end_top_bar();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /Show data/ and do {&show_data; last CASE;};
	    /Show log/ and do {&show_log; last CASE;};
	    /Stop/ and do {&stop;};
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub find_prev($)
{
    my $session = param('session');
    $session = $user->session unless ($session);
    my $nr = param('file');
    $nr = $user->get_measure_nr unless ($nr);
    my $prev;
    while (!$prev && $nr-- > 0)
    {
	$nr = sprintf("%04d",$nr);
	foreach my $f (@list)
	{
	    $prev = $nr if ($f =~ /$nr/); 
	}
	last if ($prev);
    }
    return $prev;
}

sub find_next($)
{
    my $session = param('session');
    $session = $user->session unless ($session);
    my $nr = param('file');
    $nr = $user->get_measure_nr($session) unless ($nr);
    my $next;
    while (!$next && $nr++ < $user->get_measure_nr($session))
    {
	$nr = sprintf("%04d",$nr);
	foreach my $f (@list)
	{
	    $next = $nr if ($f =~ /$nr/); 
	}
	last if ($next);
    }
    return $next;
}


sub stop()
{
    print center(h1({-class=>'Alert'},"Stopping current measurement!"));
    Elchemea::CGI_client('stop_measure');
}

sub show_data()
{
    print '<center>';
    print h2("Raw data file $file_basename");
    my $log = $file;
    my $content;
    if ($log =~ /i2[bt]$/)
    {
	$log =~s/\.(\w+)$/_long\.$1/;
    }
    if ($log)
    {
	my $f = SemaforeFile->new($log);
	$content = '';
	$content = join("\n",$f->readlines) if ($f->exist);
    }
    print textarea(-name=>'test',-value=>$content,-rows=>30,-force=>'1',-wrap=>'OFF',-style=>'width:80%');
    print '</center>';
}

sub show_log()
{
    print '<center>';
    print h2("Log for data file $file_basename");
    $log =~s/\.\w+$/\.log/;
    my $content;
    if ($log)
    {
	my $f = SemaforeFile->new($log);
	$content = '';
	$content = join("\n",$f->readlines) if ($f->exist);
    }
    print textarea(-name=>'test',-value=>$content,-cols=>80,-rows=>30,-force=>'1',-wrap=>'OFF',-style=>'width:80%');
    print '</center>';
}




sub main_page
{
    ### Generate plot ###
    my @gp = ();
    print '<center>';
    print h2("$file_basename");
    unless ($file && -e $file)
    {
	print '</center>';
	return
    }
    my $f = SemaforeFile->new($file);
    $file =~ /(\w+)\.\w+$/;
    my $outfile = $htmldir.'png/'.$1.'.png';
    my $png = '/elchemea/png/'.$1.'.png';
    my $tmpfile = $htmldir.'png/'.$1.'_tmp.png';
    my $outfile2 = $htmldir.'png/'.$1.'_2.png';
    my $png2 = '/elchemea/png/'.$1.'_2.png';
    my $tmpfile2 = $htmldir.'png/'.$1.'_tmp_2.png';
    my $rmpng1 = $1.'.png';
    my $rmpng2 = $1.'_2.png';
    push @gp,'set nokey';
    push @gp,'set term '.Elchemea::get_config_value('GNUPLOT','term');
    push @gp,"set out '$tmpfile'";
    if ($file =~ /i2c/)
    {
	$f->lock_sh;
	$f->open_read;
	my $starttime = 0;
	while (my $st = $f->readline)
	{
	    next unless ($st =~ /^([\d\.\+\-eE]+)[\s\t]+/);
	    $starttime = $1;
	    last;
	}
	$f->close;
	$f->unlock;
	push @gp,'set zeroaxis linetype -1';
	push @gp,'set x2zeroaxis linetype -1';
	push @gp,"set ylabel 'Potential (Volt)'";
	push @gp,"set y2label 'Current (A)'";
	push @gp,"set xla 'time'";
	push @gp,"set xrange[0:]";
	push @gp,"set size ".get_config_value('GNUPLOT','chronosize_view');
	push @gp,'set y2tics';
	push @gp,'set ytics nomirror';
	my $plotcmd = "plot \"<awk 'NR>4&&NF>1' $file\" u (\$1-$starttime):2 tit 'Potential' with lines,'' u (\$1-$starttime):4 axes x1y2 tit 'Current' with lines";
	push @gp,$plotcmd;
    }
    if ($file =~ /i2p/)
    {
	push @gp,'set zeroaxis linetype -1';
	push @gp,"set xlabel 'Potential (Volt)'";
	push @gp,"set ylabel 'Current (A)'";
	push @gp,"set size ".get_config_value('GNUPLOT','chronosize_view');
	my $plotcmd = "plot \"<awk 'NR>4&&NF>1' $file\" u 2:4 tit '' with lines";
	push @gp,$plotcmd;
    }
    if ($file =~ /i2b/)
    {
	push @gp,'set xrange [:]';
	push @gp,'set yrange [:]';
	push @gp,"set size ".get_config_value('GNUPLOT','impsize_view');
	push @gp,'set logscale y';
	push @gp,"set yla 'Z (Ohm)'";
	push @gp,"set xla 'log(frequency (Hz))'";
	my $plotcmd = "plot \"<awk 'NR>5&&NF>1' $file\" u (log(\$1)/log(10)):(\$3<0?-\$3:1/0) pt 3,'' u (log(\$1)/log(10)):(\$3>0?\$3:1/0) pt 3,'' u (log(\$1)/log(10)):(\$2>0?\$2:1/0) pt 2,'' u (log(\$1)/log(10)):(\$2<0?-\$2:1/0) pt 2";
	push @gp,$plotcmd;
	push @gp,'set nologscale';
	push @gp,'set zeroaxis linetype -1';
	push @gp,"set out '$tmpfile2'";
	push @gp,'set size ratio -1';
	push @gp,"set yla '-Z imaginary (Ohm)\'";
	push @gp,"set xla 'Z real (Ohm)\'";
	$plotcmd = "plot \"<awk 'NR>6&&NF>1' $file\"  u 2:(-\$3) tit '' with p pt 3";
	push @gp,$plotcmd;
    }
    if ($file =~ /i2t/)
    {
	$f->lock_sh;
	$f->open_read;
	my $x = 0;
	while (my $st = $f->readline)
	{
	    next unless ($st =~ /^([\d\.]+)\s+([\d\.]+)/);
	    $x = $1;
	    my $freq = $2+0;
	    print center(h3("Frequency: $freq Hz"));
	    last;
	}
	$f->close;
	$f->unlock;
	push @gp,'set xrange [:]';
	push @gp,'set yrange [:]';
	push @gp,"set size ".get_config_value('GNUPLOT','impsize_view');
	push @gp,'set logscale y';
	push @gp,"set yla 'Z (Ohm)'";
	push @gp,"set xla 'time (s)'";
	my $plotcmd = "plot \"<awk 'NR>5&&NF>1' $file\" u (\$1-$x):(\$4<0?-\$4:1/0) pt 3,'' u (\$1-$x):(\$4>0?\$4:1/0) pt 3,'' u (\$1-$x):(\$3>0?\$3:1/0) pt 2,'' u (\$1-$x):(\$3<0?-\$3:1/0) pt 2";
	push @gp,$plotcmd;
    }
    my $gp = SemaforeFile->new('/tmp/plot.gp','/tmp/plot.lock');
    $gp->lock_ex;
    $gp->writeline(@gp);
    my $cmd = get_config_value('GNUPLOT','location').' '.$gp->filename;
    system($cmd);
    move($tmpfile,$outfile);
    $gp->unlock;
    if ($file =~ /i2b/)
    {
	my $smode = param('showmode');
	move($tmpfile2,$outfile2);
	if ($smode && $smode =~ /bode/i)
	{
	    print '<img name="bode" src="'.$png.'">';
	}
	else
	{
	    print '<img name="imp" src="'.$png2.'">';
	}
    }
    else
    {
	print '<img name="measure_img" src="'.$png.'">';
    }
    #### Hook for Elchemea Analytic ###
    if (-e '/home/analytic/' && $file =~ /i2b$/)
    {
	my $name = '';
	my @data = ();
	my $f = SemaforeFile->new($file);
	my @lines = $f->readlines();
	my $x = 0;
	while ($x++ < @lines)
	{
	    next unless ($lines[$x] =~ /^[\s\t]*\d+[\s\t]*$/);
	    last;
	}
	while ($x++ < @lines)
	{
	    push @data,$lines[$x] if ($lines[$x] =~ /\d/);
	}
	if ($file =~ /([\w\d\-\.]+)$/)
	{
	    $name = $1;
	}
	print '<p>';
	print start_form(-action=>'../analytic/main.cgi');
	print_hidden();
	my $data = join("\n",@data);
	print hidden(-name=>'filename',-value=>$name,-force=>1);
	print hidden(-name=>'data',-value=>$data,-force=>1);
	print hidden(-name=>'mode',-value=>'plot',-force=>1);
	print hidden(-name=>'E_file',-value=>$file,-force=>1);
	print hidden(-name=>'Elchemea',-value=>1,-force=>1);
	print submit(-name=>'action',-value=>'Fit with ElchemeaAnalytic',-class=>'s7',-style=>'width:300px;');
	print end_form;
    }
    print '</center>';
    Elchemea::CGI_client('rmpng',$rmpng1);
    Elchemea::CGI_client('rmpng',$rmpng2);
}
